
-- None of the following are allowed.
--type Four a b c d = a | b | c | d
--type Four a b c d = (a | b) | (c | d)
--type Four a b c d = a | (b | (c | d))

type Four1 a b c d = Either (Either a b) (Either c d)

type Four2 a b c d = Either a (Either b (Either c d))


data Four3 a b c d = Four3 (Either (Either a b) (Either c d)) deriving Show

data Four4 a b c d = Four4 (Either a (Either b (Either c d))) deriving Show

-- We can also do this without using Either.
data Four5 a b c d = Four5a a | Four5b b | Four5c c | Four5d d deriving Show

-- Try to determine the type of each of these values.
v1 = Left (Left "x")
v2 = Left (Right "x")
v3 = Right (Left "x")
v4 = Right (Right (Left "x"))
v5 = Four4 (Left (Left "x"))
v6 = Four4 (Right (Right (Left "x")))

